#include "DHT.h"
#define DHTPIN 7
#define DHTTYPE DHT11
// #define DHTTYPE DHT22
//#define DHTTYPE DHT21

DHT dht(DHTPIN, DHTTYPE);

void setup() {
  Serial.begin(9600);
  Serial.println("Test DHT!");

  dht.begin();
}

void loop() {
  delay(2000);
  // Lettura umidità
  float h = dht.readHumidity();
  // Lettura temperatura in gradi Celsius (default)
  float t = dht.readTemperature();
  // Lettura temperatura in gradi (isFahrenheit = true)
  float f = dht.readTemperature(true);

  if (isnan(h) || isnan(t) || isnan(f)) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }
  // Calcolo indice di calore in gradi Fahrenheit (the default)
  float hif = dht.computeHeatIndex(f, h);
  // Calcolo indice di calore in gradi Celsius (isFahreheit = false)
  float hic = dht.computeHeatIndex(t, h, false);

  Serial.print("Umidit");
  Serial.print(char(224)); // stampa à
  Serial.print(": ");
  Serial.print(h);
  Serial.print(" %\t");
  Serial.print("Temperatura: ");
  Serial.print(t);
  Serial.print(" ");
  Serial.print(char(176)); // stampa simbolo °
  Serial.print(" C ");
  Serial.print(f);
  Serial.print(" ");
  Serial.print(char(176)); // stampa simbolo °
  Serial.print(" F\t");
  Serial.print("Indice di calore: ");
  Serial.print(hic);
  Serial.print(" ");
  Serial.print(char(176)); // stampa simbolo °
  Serial.print(" C ");
  Serial.print(hif);
  Serial.print(" ");
  Serial.print(char(176)); // stampa simbolo °
  Serial.println(" F");
}
