#include <DHT.h>
#include <LiquidCrystal.h>
#define TRIGGER 8
#define ECHO 9
#define DHTPIN 7
#define DHTTYPE DHT11
DHT dht(DHTPIN, DHTTYPE);
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
float Misura(int trg, int echo)
{
  digitalWrite(trg, LOW);
  digitalWrite(trg,HIGH);
  delayMicroseconds(10);
  digitalWrite(trg,LOW);
  unsigned long durata = pulseIn(echo, HIGH);
  float sSpeed = GetSoundSpeed()/20000.0;
  float d = sSpeed * durata;  
  return d;
  }
float GetSoundSpeed()  
{
  delay(2000);
  float t = dht.readTemperature(); 
  float soundspeed = 331.4 + 0.62*t;
  return soundspeed;
  }
void setup() {
  Serial.begin(9600);
  pinMode(TRIGGER, OUTPUT);
  pinMode(ECHO, INPUT);  
  lcd.begin(16, 2);
  lcd.print("Distanza (cm)");
}

void loop() {
  float distanza = Misura(TRIGGER, ECHO);
  lcd.setCursor(0, 1);
  lcd.print(distanza); 
  lcd.print("       ");  
}
