#include <LiquidCrystal.h>
#define TRIGGER 8
#define ECHO 9
#define BUZZER 10
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
byte ostacolo[8] = {
  0b00100,
  0b01010,
  0b01010,
  0b10001,
  0b10001,
  0b10001,
  0b11111,
  0b00000
};
float Misura(int trg, int echo)
{
  digitalWrite(trg, LOW);
  digitalWrite(trg,HIGH);
  delayMicroseconds(10);
  digitalWrite(trg,LOW);
  unsigned long durata = pulseIn(echo, HIGH);
  float sSpeed = 343.0;  
  float d =( sSpeed / 20000.0) * durata;  
  return d;
  }

void setup() {
  Serial.begin(9600);
  pinMode(TRIGGER, OUTPUT);
  pinMode(ECHO, INPUT);  
  pinMode(BUZZER, OUTPUT);
  lcd.begin(16, 2);
  lcd.createChar(0, ostacolo);
}

void loop() {
  float distanza = Misura(TRIGGER, ECHO);
  lcd.setCursor(0, 0);
  if (distanza<100.0)
  {
    
    int i;
    int n = map((int)distanza,0,100,0,16);
    for (i=0; i<n; i++)
      lcd.print(">");
    lcd.write(byte(0));
    for (i=n+1; i<16; i++)
      lcd.print(" ");  
      
    tone(BUZZER, 2500, 100);
  }
  else
   lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(distanza); 
  lcd.print(" Cm  ");  
  delay(int(distanza)*10);
}
