#include <Keypad.h>
#include <LiquidCrystal.h>
const byte ROWS = 4; //quattro righe keypad
const byte COLS = 4; //quattro colonne keypad
char keys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};
byte rowPins[ROWS] = {14, 15, 16, 17}; 
byte colPins[COLS] = {6, 7, 8, 9}; 
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
const byte LCDROWS = 2; //due righe LCD
const byte LCDCOLS = 16; //sedici colonne LCD
void setup(){
  Serial.begin(9600);
  lcd.begin(LCDCOLS, LCDROWS);
}
int currRow = 0; // riga del cursore
int currCol = 0; // colonna del cursore
void loop(){
  // lettura  carattere
  char key = keypad.getKey(); 
  if (key != NO_KEY)    
  {
    Serial.println(key); // utile per debug
    // se il cursore all'ultima colonna dell'ultima riga del display
    // cancello lo schermo e riporto il cursore all'inizio
    if (currCol == LCDCOLS && currRow ==1)
    {
       lcd.clear();
       currRow=0;
       currCol=0;
     }                         
     lcd.print(key);
     currCol++; // aggiorno la posizione del cursore
     // se il cursore è alla fine della riga corrente
     // porto il cursore alla colonna 0 della riga successiva
     if (currCol == LCDCOLS)
        if (currRow ==0)
         {
           currRow++; 
           currCol=0;
           lcd.setCursor(0,1);
         }       
  }
}  
